﻿Public Class Form1
    WithEvents IVEvent As Inventor.ApplicationEvents
    Dim oInventorApp As Inventor.Application
    Dim oIVBoom As Inventor.AssemblyDocument
    Dim oIVDraw As Inventor.DrawingDocument
    Dim oIVPart As Inventor.PartDocument
    Dim oIVDoc As Inventor.Document




    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        oInventorApp = System.Runtime.InteropServices.Marshal.GetActiveObject("Inventor.Application") 'GetObject(, "Inventor.Application")
        IVEvent = oInventorApp.ApplicationEvents
    End Sub


    Private Sub beendenbt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles beendenbt.Click
        Close()
    End Sub


    Private Sub ivsteuernbt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ivsteuernbt.Click
        oInventorApp = System.Runtime.InteropServices.Marshal.GetActiveObject("Inventor.Application")
        oIVPart = oInventorApp.ActiveDocument
        oIVPart.Close(False)
    End Sub


    Private Sub massstabaendernbt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles zeichnungaendernbt.Click
        oIVDraw = oInventorApp.ActiveDocument
        For i As Integer = 1 To oIVDraw.ActiveSheet.DrawingViews.Count
            If Not oIVDraw.ActiveSheet.DrawingViews.Item(i).ScaleFromBase Then
                oIVDraw.ActiveSheet.DrawingViews.Item(i).ScaleString() = massstabtb.Text
                'If oIVDraw.ActiveSheet.DrawingViews.Item(i).ViewType = DrawingViewTypeEnum.kProjectedDrawingViewType Then
                'hier könnte zwischen den unterschiedlichen Anichtstypen unterschieden werden und ein anderer Maßstab zugeordnet werden...
                'End If
                MessageBox.Show(oIVDraw.ActiveSheet.DrawingViews.Item(i).ViewType.ToString)
            End If

        Next
    End Sub

    Public Sub IVEvent_OnOpenDocument(ByVal DocumentObject As Document, _
                                       ByVal FullDocumentName As String, _
                                       ByVal BeforeOrAfter As EventTimingEnum, _
                                       ByVal Context As NameValueMap, _
                                       ByRef HandlingCode As HandlingCodeEnum) Handles IVEvent.OnOpenDocument

        Dim i As Long
        For i = 1 To Context.Count
            Debug.Print("Context: ", Context.Name(i), Context.Value(Context.Name(i)))
        Next

        Select Case BeforeOrAfter
            Case EventTimingEnum.kAfter
                Debug.Print(" Timing: After")
                If oInventorApp.ActiveDocumentType = DocumentTypeEnum.kDrawingDocumentObject Then
                    If cbzeichnungaktualisieren.Checked Then
                        massstabberechnenbt_Click(masstabaendernbt, EventArgs.Empty)
                        massstabaendernbt_Click(zeichnungaendernbt, EventArgs.Empty)
                    End If
                End If

            Case EventTimingEnum.kBefore
                Debug.Print(" Timing: Before")
            Case Else
                Debug.Print(" Timing: Aborted")
        End Select
    End Sub


    
    Private Sub massstabberechnenbt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles masstabaendernbt.Click

        oIVDoc = oInventorApp.ActiveDocument
        Dim pfad As String = ""

        '#1 liest den Pfad aller referenzierten dateien aus
        Dim oRefFileDesc As ReferencedFileDescriptor
        For Each oRefFileDesc In oIVDoc.ReferencedFileDescriptors
            pfad = oRefFileDesc.FullFileName
        Next
        '#1

        oInventorApp.Documents.Open(pfad)
        oIVDoc = oInventorApp.ActiveDocument
        Dim temp As String = oIVPropread(4, ivparnametb.Text, True)
        oIVDoc.Save()
        oIVDoc.Close(False)
        Dim massstab As Double = (CDbl(temp) / CDbl(breiteansichttb.Text))

        If massstabrundencb.Checked Then
            massstab = (Math.Floor(CDbl(massstab)).ToString) 'CDBL konvertiert den String in eine Doublezahl
        End If
        ' Das Aktualisierungsobjekt erstellen.


        Dim Updater As New ControlTextUpdater(massstabtb)

        ' Eine thread-sichere Aktualisierung durchführen.

        Updater.ReplaceText(("1:" & massstab.ToString))

        'massstabaendernbt_Click(masstabaendernbt, e)


        'mftb.Text = mftb.Text + "**" + oIVDraw.ReferencedDocumentDescriptors
        'mftb.Text = mftb.Text + oIVDoc.File.ToString

    End Sub






    '*************** eigene Funktionen ************************

    'auslesen einer bestimmten iPropertie 
    Public Function oIVPropread(ByVal propgroup As Integer, ByVal propname As String, ByVal Zahl As Boolean) As String
        Dim ivvargruppe As String = ""
        Select Case propgroup
            Case 1
                ivvargruppe = "Inventor Summary Information" '**Inventor - Zusammenfassungsinformationen
            Case 2
                ivvargruppe = "Inventor Document Summary Information" '**Inventor - Zus.-fassungsinfo f. Dokument
            Case 3
                ivvargruppe = "Design Tracking Properties" '**Design Tracking - Eigenschaften
            Case 4
                ivvargruppe = "Inventor User Defined Properties" '**Inventor - Benutzerdefinierte Eigenschaften
        End Select

        Dim props As PropertySet
        Dim prop As [Property]
        Dim wert As String = ""
        oIVDoc = oInventorApp.ActiveDocument
        For Each props In oIVDoc.PropertySets()
            'mftb.Text = mftb.Text + "**" + props.DisplayName + vbCrLf + props.Name + vbCrLf
            If props.Name = ivvargruppe Then
                For Each prop In props
                    If prop.DisplayName = propname Then
                        Try
                            wert = prop.Value.ToString
                        Catch ex As Exception
                            '####muss noch programmiert werden
                        End Try
                        Exit For
                    End If
                Next
            End If
        Next
        'Rückgabeart bestimmen und evt "mm" abschneiden
        Dim temp As String = ""
        If Zahl Then
            For i As Integer = 0 To Len(wert) - 1
                Select Case wert(i)
                    Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ","
                        temp = temp + wert(i)
                    Case "." 'mit "." als Dezimalpunkt rechnet VB falsch, daher Umwandlung in ","
                        '####gibt es einen Zusammenhang mit den Windows Grundeinstellungen ?? - noch überprüfen
                        temp = temp + ","
                End Select
            Next i
        Else
            temp = wert
        End If
        Return (temp)

        'oIVDraw.PropertySets.FlushToFile()'speichert Änderungen der iProperties

    End Function

    '******ENDE********* eigene Funktionen ***********ENDE*************

   
    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()

    End Sub

    
    Private Sub alleipropauslesenbt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles alleipropauslesenbt.Click
        Dim props As PropertySet
        Dim prop As [Property]
        Dim wert As String = ""
        Dim i As Integer = 0
        Dim gruppenzaehler As Integer = 0
        oIVDoc = oInventorApp.ActiveDocument
        proplistview.Groups.Clear()
        If oInventorApp.ActiveDocumentType = DocumentTypeEnum.kNoDocument Then
            MessageBox.Show("Kein Dokument in Inventor geladen.", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        Try
            proplistview.BeginUpdate()

            For Each props In oIVDoc.PropertySets()
                Dim gruppe As New ListViewGroup(props.DisplayName, props.DisplayName)
                proplistview.Groups.Add(gruppe)
                For Each prop In props
                    Try
                        Dim temp As New ListViewItem(prop.DisplayName, i) 'i gibt den Imageindex an
                        temp.SubItems.Add(prop.Name)
                        temp.SubItems.Add(prop.Value)
                        temp.Group = proplistview.Groups(gruppenzaehler)
                        proplistview.Items.Add(temp)
                        i = i + 1
                    Catch ex As Exception
                        '####muss noch programmiert werden
                    End Try
                Next
                gruppenzaehler = gruppenzaehler + 1
            Next
        Catch ex As Exception

        End Try
        proplistview.EndUpdate()
    End Sub

    
    Private Sub bt__Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_bemzentrieren.Click
        oIVDraw = oInventorApp.ActiveDocument
        Dim oSheet As Sheet
        oSheet = oIVDraw.ActiveSheet
        Dim oDrawingDim As Inventor.DrawingDimension

        For Each oDrawingDim In oSheet.DrawingDimensions
            If TypeOf oDrawingDim Is LinearGeneralDimension Or _
            TypeOf oDrawingDim Is AngularGeneralDimension Then
                Call oDrawingDim.CenterText()

            End If
        Next
    End Sub

    Private Sub bt_ausrichtenbem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_ausrichtenbem.Click
        Dim oDrawDoc As DrawingDocument

        oDrawDoc = oInventorApp.ActiveDocument

        ' Determine if there are any dimensions in the select set.
        Dim oSelectSet As SelectSet
        oSelectSet = oDrawDoc.SelectSet
        Dim colDimensions As New Collection
        Dim i As Long
        For i = 1 To oSelectSet.Count
            If TypeOf oSelectSet.Item(i) Is DrawingDimension Then
                ' Add any dimensions to the collection. We need to save them
                ' in something besides the selection set because once we start
                ' manipulating them the select set will be cleared.
                colDimensions.Add(oSelectSet.Item(i))
            End If
        Next

        If colDimensions.Count < 2 Then
            MsgBox("Sie müssen mindesten zwei Bemaßungen auswählen.")
            Exit Sub
        End If

        ' Ask the user if he/she wants vertical or horizontal alignment.
        Dim bHorizontal As Boolean
        If MsgBox("Möchten sie die Bemaßung Horizontal ausrichten? (Bei Nein wird sie Vertikal ausgerichtet.)", vbQuestion + vbYesNo, "Align Dimensions") = vbYes Then
            bHorizontal = True
        Else
            bHorizontal = False
        End If

        For i = 1 To colDimensions.Count
            Dim oDimension As DrawingDimension
            oDimension = colDimensions.Item(i)
            Dim dPosition As Double
            If i = 1 Then
                ' Get the position of the first dimension text. This is
                ' the position the other dimensions will be aligned to.

                If bHorizontal Then
                    dPosition = oDimension.Text.Origin.Y
                Else
                    dPosition = oDimension.Text.Origin.X
                End If
            Else
                ' Change the position of the dimension.
                Dim oPosition As Point2d
                oPosition = oDimension.Text.Origin
                If bHorizontal Then
                    oPosition.Y = dPosition
                Else
                    oPosition.X = dPosition
                End If
                oDimension.Text.Origin = oPosition
            End If
        Next

    End Sub

    Private Sub bt_bemerzeugen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_bemerzeugen.Click
        ' Set a reference to the drawing document.
        ' This assumes a drawing document is active.
        Dim oDrawDoc As DrawingDocument
        oDrawDoc = oInventorApp.ActiveDocument

        ' Set a reference to the active sheet.
        Dim oActiveSheet As Sheet
        oActiveSheet = oDrawDoc.ActiveSheet

        ' Set a reference to the drawing curve segment.
        ' This assumes that a linear drawing curve is selected.
        Dim oDrawingCurveSegment As DrawingCurveSegment
        If oDrawDoc.SelectSet.Count <= 0 Then
            MessageBox.Show("Bitte wählen sie eine oder mehrere lineare Objektkanten aus.")
            Exit Sub
        End If
        oDrawingCurveSegment = oDrawDoc.SelectSet.Item(1)

        ' Set a reference to the drawing curve.
        Dim oDrawingCurve As DrawingCurve
        oDrawingCurve = oDrawingCurveSegment.Parent

        If Not oDrawingCurve.CurveType = CurveTypeEnum.kLineSegmentCurve Then
            MsgBox("Es sind nur lineare Objektkanten erlaubt.")
            Exit Sub
        End If


        ' Create point intents to anchor the dimension to.
        Dim oDimIntent1 As GeometryIntent
        oDimIntent1 = oActiveSheet.CreateGeometryIntent(oDrawingCurve, PointIntentEnum.kStartPointIntent)

        Dim oDimIntent2 As GeometryIntent
        oDimIntent2 = oActiveSheet.CreateGeometryIntent(oDrawingCurve, PointIntentEnum.kEndPointIntent)

        ' Set a reference to the view to which the curve belongs.
        Dim oDrawingView As DrawingView
        oDrawingView = oDrawingCurve.Parent

        ' If origin indicator has not been already created, create it first.
        If Not oDrawingView.HasOriginIndicator Then
            ' The indicator will be located at the start point of the selected curve.
            'oDrawingView.CreateOriginIndicator(oDimIntent1)
        End If

        ' Set a reference to the ordinate dimensions collection.
        Dim oOrdinateDimensions As OrdinateDimensions
        oOrdinateDimensions = oActiveSheet.DrawingDimensions.OrdinateDimensions

        ' Create the x-axis vector
        Dim oXAxis As Vector2d
        oXAxis = oInventorApp.TransientGeometry.CreateVector2d(1, 0)

        Dim oCurveVector As Vector2d
        oCurveVector = oDrawingCurve.StartPoint.VectorTo(oDrawingCurve.EndPoint)

        Dim oTextOrigin1 As Point2d
        Dim oTextOrigin2 As Point2d
        Dim DimType As DimensionTypeEnum

        If oCurveVector.IsParallelTo(oXAxis) Then
            ' Selected curve is horizontal
            DimType = DimensionTypeEnum.kVerticalDimensionType


            ' Set the text points for the 2 dimensions.
            oTextOrigin1 = oInventorApp.TransientGeometry.CreatePoint2d(oDrawingCurve.StartPoint.X, oDrawingView.Top + 5)
            oTextOrigin2 = oInventorApp.TransientGeometry.CreatePoint2d(oDrawingCurve.EndPoint.X, oDrawingView.Top + 5)

        Else
            ' Selected curve is vertical or at an angle.
            DimType = DimensionTypeEnum.kHorizontalDimensionType

            ' Set the text points for the 2 dimensions.
            oTextOrigin1 = oInventorApp.TransientGeometry.CreatePoint2d(oDrawingView.Left - 5, oDrawingCurve.StartPoint.Y)
            oTextOrigin2 = oInventorApp.TransientGeometry.CreatePoint2d(oDrawingView.Left - 5, oDrawingCurve.EndPoint.Y)

        End If
        Dim test As Inventor.DrawingDimension
        Dim nb = oActiveSheet.DrawingDimensions.GeneralDimensions


        test = nb.AddLinear(oTextOrigin1, oDimIntent1, oDimIntent2, DimensionTypeEnum.kHorizontalDimensionType)
        Exit Sub


        ' Create the first ordinate dimension.
        Dim oOrdinateDimension1 As OrdinateDimension
        oOrdinateDimension1 = oOrdinateDimensions.Add(oDimIntent1, oTextOrigin1, DimType)


        ' Create the second ordinate dimension.
        Dim oOrdinateDimension2 As OrdinateDimension
        oOrdinateDimension2 = oOrdinateDimensions.Add(oDimIntent2, oTextOrigin2, DimType)


        
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' Set a reference to the assembly document.
        ' This assumes an assembly document is active.

        oIVBoom = oInventorApp.ActiveDocument

        ' Set a reference to the BOM
        Dim oBOM As BOM = oIVBoom.ComponentDefinition.BOM


        ' Set the structured view to 'all levels'
        'oBOM.StructuredViewFirstLevelOnly = False

        ' Make sure that the structured view is enabled.
        'oBOM.StructuredViewEnabled = True

        ' Set a reference to the "Structured" BOMView
        Dim oStructuredBOMView As BOMView
        '
        'oStructuredBOMView = oBOM.BOMViews.Item("Detailgenauigkeit1")
        For i As Integer = 1 To oBOM.BOMViews.Count
            MessageBox.Show(oBOM.BOMViews.Item(i).ToString)


        Next

        ' Export the BOM view to an Excel file
        oIVBoom.oStructuredBOMView.Export("C:\temp\BOM-StructuredAllLevels.xls", FileFormatEnum.kMicrosoftExcelFormat)

        ' Make sure that the parts only view is enabled.
        oBOM.PartsOnlyViewEnabled = True

        ' Set a reference to the "Parts Only" BOMView
        Dim oPartsOnlyBOMView As BOMView
        oPartsOnlyBOMView = oBOM.BOMViews.Item("Parts Only")

        ' Export the BOM view to an Excel file
        oPartsOnlyBOMView.Export("C:\temp\BOM-PartsOnly.xls", FileFormatEnum.kMicrosoftExcelFormat)
    End Sub
End Class


Public Class ControlTextUpdater

    Private _NewText As String

    ' Der Verweis wird als generisches Steuerelement gespeichert, so dass
    ' diese Hilfsklasse in anderen Szenarien wiederverwendet werden kann.
    Private _ControlToUpdate As Control

    Public ReadOnly Property ControlToUpdate() As Control
        Get
            Return _ControlToUpdate
        End Get
    End Property

    Public Sub New(ByVal controlToUpdate As Control)
        Me._ControlToUpdate = controlToUpdate
    End Sub

    Public Sub AddText(ByVal newText As String)
        SyncLock Me
            Me._NewText = newText
            ControlToUpdate.Invoke(New MethodInvoker(AddressOf ThreadSafeAddText))
        End SyncLock
    End Sub

    Private Sub ThreadSafeAddText()
        Me.ControlToUpdate.Text &= _NewText
    End Sub

    Public Sub ReplaceText(ByVal newText As String)
        SyncLock Me
            Me._NewText = newText
            ControlToUpdate.Invoke(New MethodInvoker(AddressOf ThreadSafeReplaceText))
        End SyncLock
    End Sub

    Private Sub ThreadSafeReplaceText()
        Me.ControlToUpdate.Text = _NewText
    End Sub

End Class
